//---------------------------------------------------------------------------

#include <vcl.h>
#include <vector>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit3.h"
#include "Unit4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SrvAccept(TObject *Sender,
      TCustomWinSocket *Socket)
{
        log("Accepting connection");
        Connection c;
        c.handle = Socket->SocketHandle;
        c.owner = this;
        connections.push_back(c);
}

void TForm1::log(AnsiString text) {
        LogMemo->Lines->Add(text);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
        if (Srv->Active) {
                Srv->Active = false;
                Button1->Caption = "Start server";
                log("Stoping server");
                Button2->Enabled = true;
        } else {
                Srv->Active = true;
                Button1->Caption = "Stop server";
                log("Starting server");
                Button2->Enabled = false;
        }        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SrvClientConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
        log("Client connected");        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SrvClientDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
        log("Client disconnected");
        for (std::vector<Connection>::iterator it = connections.begin(); it != connections.end(); ++it) {
                if (it->handle == Socket->SocketHandle) {//find this connetion
                        connections.erase(it);//it is no longer needed
                        break;
                }
        }     
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SrvClientRead(TObject *Sender,
      TCustomWinSocket *Socket)
{

        Connection *c;
        for (std::vector<Connection>::iterator it = connections.begin(); it != connections.end(); ++it) {
                if (it->handle == Socket->SocketHandle) {//find this connection
                        c = it;//remember it
                        break;
                }
        }
        log("receiving data from client");
        AnsiString data = c->theRest + Socket->ReceiveText();//Copak nam to poslal?
        std::vector<AnsiString> lines;
        AnsiString line = "";
        int lastNewLine = 0;
        for (int i = 1; i <= data.Length(); ++i) {//Divide to lines
                switch (data[i]) {
                        case 13: {//new line
                                lines.push_back(line);//add it to the list
                                line = "";//it is empty now
                                lastNewLine = i;
                                break;
                        }
                        case 10: {//Ignore the second part of new line
                                break;
                        }
                        default: {
                                line += data[i];//Append the char
                        }
                }
        }
        c->theRest = data.SubString(lastNewLine + 1, data.Length() - lastNewLine);//remember all that was not new-lined yet
        c->feed(lines, Socket);//feed it and that's all
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
        TForm3 *options = new TForm3(this);
        options->Port->Value = Srv->Port;
        options->Edit1->Text = fileName;
        if (options->ShowModal() == mrOk) {
                setOptions(options->Edit1->Text, options->Port->Value);
        }
        delete options;
}
//---------------------------------------------------------------------------
void TForm1::setOptions(const AnsiString &fileName, int port) {
        TForm4 *splash = new TForm4(this);
        try {
                this->fileName = fileName;
                Srv->Port = port;
                splash->Show();
                splash->Update();

                stanice.clear();

                FILE *f = fopen(fileName.c_str(), "rt");
                if (!f) throw 1;

                char buff[1024000];
                char *line;
                bool inTag = false;
                AnsiString tag = "";
                AnsiString body = "";
                AnsiString cisloLinky = "";
                AnsiString pijezd = "";
                AnsiString odjezd = "";
                while ((line = fgets(buff, 102400, f)) != NULL) {//read all the lines
                        for (char *c =line; *c; ++c) {
                                switch (*c) {
                                        case '<': {//tag opening
                                                inTag = true;
                                                break;
                                        }
                                        case '>': {//tag closing
                                                if (inTag) {//Tohle je v body povoleny
                                                        inTag = false;
                                                        tag = tag.Trim();
                                                        if (tag[1] == '/') {//uzaviraci tag
                                                                tag = tag.SubString(2, tag.Length() - 1).Trim();
                                                                if (tag.UpperCase().AnsiCompare("LINKA") == 0) {

                                                                } else if (tag.UpperCase().AnsiCompare("STANICE") == 0) {
                                                                        bool found = false;
                                                                        for (std::vector<AnsiString>::iterator it = stanice.begin(); it != stanice.end(); ++it) {
                                                                                if (it->AnsiCompare(body) == 0) {//tuhle stanici uz mame
                                                                                        found = true;
                                                                                        break;
                                                                                }
                                                                        }
                                                                        if (!found)//tahle tu este nejni
                                                                                stanice.push_back(body);
                                                                        body = "";
                                                                }
                                                        } else {//oteviraci tag, dostan z nej parametry
                                                                body = "";
                                                        }
                                                        tag = "";
                                                        break;

                                                }
                                        }
                                        default: {
                                                if (inTag) {
                                                        tag += *c;
                                                } else {
                                                        body += *c;
                                                }
                                        }
                                }
                        }
                }

                fclose(f);
                splash->Close();
                Button2->Caption = fileName + ", port " + IntToStr(port) + ": zmen";
        }
        catch (...) {
                ShowMessage("Neplatne zadani");
                setOptions("data.xml", 80);
                splash->Close();
        }
}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        setOptions("data.xml", 80);//default value        
}
//---------------------------------------------------------------------------
